/******************************************************************/
/*                                                                */
/* PARTI : Parallel Automated Runtime Tools from ICASE            */
/* Version 1.0          8 July 1990                               */
/*                                                                */
/* This is the header file for the parti primitives.              */
/* This only includes stuff that a user might need to see. Message*/
/* types and so on are defined in the file parti_more.h           */
/* - Harry Scott Berryman                                         */
/******************************************************************/
/* compiler communication pattern */
struct com_pattern {
  int n_msgs_to_recv,n_msgs_to_send;
  int *send_n,**send_list;
  int *fetch_n,**fetch_list;
  int ncolor, *gcolor;
  int  *scolor;
  int buffer_size;
  int nprocs,myproc,pid;
};

struct com_pattern *schedule_gather();
void execute_gather(),iexecute_gather(),fexecute_gather();
void dexecute_gather(),cexecute_gather();
void execute_scatter(),iexecute_scatter(),fexecute_scatter();
void dexecute_scatter(),cexecute_scatter();
void iexecute_add(),fexecute_add();
void dexecute_add(),cexecute_add(); 
void iexecute_sub(),fexecute_sub(); 
void dexecute_sub(),cexecute_sub();
void iexecute_mult(),fexecute_mult(); 
void dexecute_mult(),cexecute_mult();

/* user communication pattern (is a compiler pattern + perm vector to unpack) */
#define SCHED struct schedule_struct
struct schedule_struct {
  struct com_pattern *sr;
  int ndata,*perm;
  int *global_refs,*local_refs;
};

/* Maximum dimensions to be set here when using block gather  */
#define MAXDIM  5        

/* structure for translation talble */
#define BLOCKED 1
#define STRIPED 2
#define TTABLE struct trans_table
struct trans_table {
  int *proc,*offset;
  int type,table_size;
};

/* working buffer for parti for communcation purpose */
struct WBuffer {
	char	*buffer;
	int		*msg_id;
	int	max_size;
} ;
struct WBuffer *wbuffer;

/* user-level prototypes */
SCHED *schedule(),*ischedule();
SCHED *schedulen();
void dref();
void gather(),igather(),fgather(),dgather(),cgather();
void scatter(),iscatter(),fscatter(),dscatter(),cscatter();
void iscatter_add(),fscatter_add(),dscatter_add(),cscatter_add();
void iscatter_sub(),fscatter_sub(),dscatter_sub(),cscatter_sub();
void iscatter_mult(),fscatter_mult(),dscatter_mult(),cscatter_mult();
TTABLE *build_translation_table();
void new_dref(),free_table();

/* utils prototypes */
void check_point();
void print_com_pattern();
void bsort();
void check_sum();
